<script setup lang="ts">
    import { InterventionFilters } from '@/elusServiceOffer/entities/filters/InterventionFilters'
    import { Intervention } from '@/elusServiceOffer/entities/intervention/Intervention'
    import { ref, watch, Ref } from 'vue'

    interface Props {
        modelValue: InterventionFilters
        openList?: () => void
        interventions: Intervention[]
    }

    const props = defineProps<Props>()

    const filters: Ref<InterventionFilters> = ref(props.modelValue)

    watch(props, () => {
        filters.value = props.modelValue
    })

    defineEmits(['update:modelValue'])
    const expandPanel = ref<boolean>(false)
    document.addEventListener('toggleSideSheet', () => {
        expandPanel.value = !expandPanel.value
    })
    const availableStatus = ['A faire', 'En cours', 'Terminé', 'Annulé']
    const availableRegroupment = [
        'Voirie - Autres',
        'Voirie - Maçonnerie de voirie niveau 2',
        'Voirie - Intervention et Sécurité Niveau 1',
        "Voirie - Ouvrage d'art/murs soutènement niv. 2",
    ]

    const hasIncorrectDateRange = (beginDate: Date, endDate: Date) => {
        if (beginDate > endDate) {
            return 'La date de début doit être inférieure ou égale à la date de fin'
        }
    }

    const isHoveredCheckbox = ref<string>('')

    const setHoveredCheckbox = (value: string) => {
        isHoveredCheckbox.value = value
    }

    const regroupmentCounts = ref<Record<string, number>>({})
    const statusCounts = ref<Record<string, number>>({})

    watch(
        () => [props.interventions, filters.value],
        () => {
            regroupmentCounts.value = props.interventions.reduce(
                (counts: Record<string, number>, intervention) => {
                    const regroupment = intervention.regroupment
                    counts[regroupment] = (counts[regroupment] || 0) + 1
                    return counts
                },
                {}
            )

            statusCounts.value = props.interventions.reduce(
                (counts: Record<string, number>, intervention) => {
                    const status = intervention.currentStatus
                    counts[status] = (counts[status] || 0) + 1
                    return counts
                },
                {}
            )
        }
    )
</script>

<template>
    <div class="d-md-flex flex-column">
        <span class="d-flex align-center ma-4 mb-0">
            <v-icon size="x-large">mdi-filter-outline</v-icon>
            <h2 class="text-h8 ml-2">Filtres</h2>
            <v-badge
                v-if="filters.hasFilters()"
                data-cy="tune-badge"
                :offset-y="5"
                :offset-x="5"
                color="error"
                class="ml-auto"
                :content="filters.getFilterQuantity()"
            >
                <v-btn
                    variant="outlined"
                    icon="mdi-filter-remove-outline"
                    rounded="rounded"
                    :disabled="!filters.hasFilters()"
                    @click="filters.reset()"
                    @click:close="filters.reset()"
                ></v-btn>
            </v-badge>
            <v-btn
                v-else
                variant="outlined"
                icon="mdi-filter-remove-outline"
                rounded="rounded"
                class="ml-auto"
                :disabled="!filters.hasFilters()"
            ></v-btn>
            <v-btn
                v-if="$vuetify.display.mdAndUp"
                variant="outlined"
                icon="mdi-format-list-bulleted-square"
                rounded="rounded"
                class="ml-2"
                @click="props.openList"
            ></v-btn>
        </span>
    </div>
    <slot></slot>
    <v-list lines="one" density="compact">
        <v-list-item-title class="font-weight-bold ml-3 my-3"
            >Date de création</v-list-item-title
        >
        <span class="d-flex mx-4 flex-column flex-md-row">
            <v-text-field
                v-model="filters.beginCreatedAt"
                type="date"
                density="compact"
                class="date-picker my-2"
                label="Début"
                :error="filters.beginCreatedAt > filters.endCreatedAt"
                :hide-details="true"
            ></v-text-field>
            <v-spacer></v-spacer
            ><v-text-field
                v-model="filters.endCreatedAt"
                type="date"
                density="compact"
                class="date-picker my-2"
                label="Fin"
                :error="filters.beginCreatedAt > filters.endCreatedAt"
                :hide-details="true"
            ></v-text-field>
        </span>
        <div
            v-if="
                hasIncorrectDateRange(
                    filters.beginCreatedAt,
                    filters.endCreatedAt
                )
            "
            class="mx-5 text-subtitle-2 text-error"
        >
            {{
                hasIncorrectDateRange(
                    filters.beginCreatedAt,
                    filters.endCreatedAt
                )
            }}
        </div>

        <v-list-item-title class="font-weight-bold ml-3 my-3"
            >Regroupement</v-list-item-title
        >
        <v-list-item
            v-for="regroupment in availableRegroupment"
            :key="regroupment"
            density="compact"
        >
            <v-checkbox
                v-model="filters.regroupment"
                :label="`${regroupment} ${
                    regroupmentCounts[regroupment] > 0
                        ? `(${regroupmentCounts[regroupment]})`
                        : ''
                }`"
                :value="regroupment"
                hide-details
                color="primary"
                class="rounded"
                :style="{
                    background:
                        isHoveredCheckbox === regroupment ? '#F0F2F4' : '',
                    transition: 'background 0.2s ease-in-out',
                }"
                @mouseover="setHoveredCheckbox(regroupment)"
                @mouseleave="setHoveredCheckbox('')"
            ></v-checkbox>
        </v-list-item>

        <v-list-item-title class="font-weight-bold ml-3 my-3"
            >Statut</v-list-item-title
        >
        <v-list-item
            v-for="status in availableStatus"
            :key="status"
            density="compact"
        >
            <v-checkbox
                v-model="filters.statuses"
                data-cy="status-filter"
                :label="`${status} ${
                    statusCounts[status] > 0 ? `(${statusCounts[status]})` : ''
                }`"
                :value="status"
                hide-details
                color="primary"
                class="rounded"
                :style="{
                    background: isHoveredCheckbox === status ? '#F0F2F4' : '',
                    transition: 'background 0.2s ease-in-out',
                }"
                @mouseover="setHoveredCheckbox(status)"
                @mouseleave="setHoveredCheckbox('')"
            ></v-checkbox>
        </v-list-item>
        <v-list-item-title class="font-weight-bold ml-3 my-3"
            >Date du statut</v-list-item-title
        >
        <span class="d-flex mx-4 flex-column flex-md-row"
            ><v-text-field
                v-model="filters.beginStatusChangedAt"
                type="date"
                density="compact"
                class="date-picker my-2"
                label="Début"
                :error="
                    filters.beginStatusChangedAt > filters.endStatusChangedAt
                "
                :hide-details="true"
            ></v-text-field
            ><v-spacer></v-spacer
            ><v-text-field
                v-model="filters.endStatusChangedAt"
                type="date"
                density="compact"
                class="date-picker my-2"
                label="Fin"
                :error="
                    filters.beginStatusChangedAt > filters.endStatusChangedAt
                "
                :hide-details="true"
            ></v-text-field
        ></span>
        <div
            v-if="
                hasIncorrectDateRange(
                    filters.beginStatusChangedAt,
                    filters.endStatusChangedAt
                )
            "
            class="mx-5 text-subtitle-2 text-error"
        >
            {{
                hasIncorrectDateRange(
                    filters.beginStatusChangedAt,
                    filters.endStatusChangedAt
                )
            }}
        </div>
    </v-list>
</template>

<style scoped lang="scss">
    .close-btn-right {
        position: absolute;
        right: 10px;
        top: 10px;
    }

    .date-picker :is(input) {
        padding: 0;
        cursor: pointer;

        &::-webkit-calendar-picker-indicator {
            padding: 16px;
            cursor: pointer;
        }
        &::-webkit-datetime-edit-day-field {
            margin-left: 16px;
            cursor: pointer;
        }
    }
</style>
